//Werte der Form "x35y-20" werden übergeben, die Zielkoordinaten erhalten dann xziel = 35, yziel = -20. Es können aber auch einzelne Koordianten geschickt werden, es muss lediglich x oder y davorstehen

#include <string.h>
int xAktuell= 0;       //aktueller Wert von x
int yAktuell= 0;       //aktueller Wert von y

int xZiel;         //xziel beihnaltet den Wert für x, der als nächter Punkt angesteuert wird 
int yZiel;         //yziel beihnaltet den Wert für y, der als nächter Punkt angesteuert wird 

//von Sonia:
int pause = 500; // Wartezeit zwischen Richtungswechsel
int schnell = 700;
int xPinAction = 3;
int xPinRichtung = 2;
int yPinAction = 5;
int yPinRichtung = 4;

void setup()
{
 Serial.begin(9600);
 pinMode(xPinRichtung, OUTPUT);
 pinMode(yPinRichtung, OUTPUT);
 pinMode(xPinAction, OUTPUT);
 pinMode(yPinAction, OUTPUT);
}


void geheNach()
{
  int xRichtung;
  int yRichtung;
  int xAbstand = abs(xAktuell-xZiel);     //betragsmäßige Differenz zwischen xaktuell und xziel
  int yAbstand = abs(yAktuell-yZiel);     //betragsmäßige Differenz zwischen yaktuell und yziel

  
  if (xAktuell >= xZiel)                  //wenn der Wert von xaktuell >= xziel ist,...
  {
    digitalWrite(xPinRichtung, HIGH);    //...wird xrichtung auf 0 gesetzt, d.h., dass die Platte um xabstand Schritte nach rechts verschoben werden muss
    xBewegen(xAbstand);
    delay(pause);
  }                        
  else 
  {
    digitalWrite(xPinRichtung, LOW);    //sonst wird xrichtung auf 1 gesetzt, d.h., dass die Platte um xabstand Schritte nach links verschoben werden muss
    xBewegen(xAbstand);
    delay(pause);
  }  

                        
  if (yAktuell >= yZiel)                  //wenn der Wert von yaktuell >= yziel ist,...
  {
    digitalWrite(yPinRichtung, HIGH);    //...wird yrichtung auf 0 gesetzt, d.h., dass die Platte um yabstand Schritte nach oben verschoben werden muss
    yBewegen(yAbstand);
    delay(pause);
  }                       
  else                                       
  {
    digitalWrite(yPinRichtung, LOW);  //sonst wird yrichtung auf 1 gesetzt, d.h., dass die Platte um yabstand Schritte nach unten verschoben werden muss
    yBewegen(yAbstand);
    delay(pause);
  }                        
}


void xBewegen(int laenge) {
  int verzoegerung = 300;
  for (int i = 0; i <= laenge*106; i++){
        digitalWrite(xPinAction, HIGH);
        delayMicroseconds(schnell+verzoegerung);
        digitalWrite(xPinAction, LOW);
        delayMicroseconds(schnell+verzoegerung);
        if(verzoegerung>0){
          verzoegerung = verzoegerung - 20;
        }
     }
  }



void yBewegen(int laenge) {
    int verzoegerung = 300;
    for (int i = 0; i <= laenge*106; i++) {
        digitalWrite(yPinAction, HIGH);
        delayMicroseconds(schnell+verzoegerung);   //verzögerung testen
        digitalWrite(yPinAction, LOW);
        delayMicroseconds(schnell+verzoegerung);
        if(verzoegerung>0){
          verzoegerung = verzoegerung - 20;
       }
    }
    
}



void loop()
{
  if (Serial.available() > 0) {           //Solange Werte den Arduino erreichen, werden auch Werte ausgewertet
      int richtung = Serial.read();
      switch (richtung)    {
      case 'x':                          //wenn in der Zeichenfolge ein x gefunden wird,...
      {
        xZiel = Serial.parseFloat();     //...werden die nachfolgenden Zahlen als xziel gespeichert
        Serial.print("xZiel = ");
        Serial.println(xZiel);
        break;
      }
      case 'y':                        //wenn in der Zeichenfolge ein x gefunden wird,...
      {
        yZiel = Serial.parseFloat();   //...werden die nachfolgenden Zahlen als yziel gespeichert
        Serial.print("yZiel = ");
        Serial.println(yZiel);
        break;
      }
      default:                        //wenn in der Zeichenfolge etwas gefunden wird, was nicht zugeordnet werden kann,...
      Serial.println("default");      //...wird "default" auf dem Serial Monitor ausgegeben
      
      break;
    }
  }
  geheNach();
}


